<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJPSOAP_HotelAvailStopSale ArrayType
 * @subpackage Arrays
 */
class ArrayOfJPSOAP_HotelAvailStopSale extends AbstractStructArrayBase
{
    /**
     * The StopSale
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JPSOAP_HotelAvailStopSale[]
     */
    public $StopSale;
    /**
     * Constructor method for ArrayOfJPSOAP_HotelAvailStopSale
     * @uses ArrayOfJPSOAP_HotelAvailStopSale::setStopSale()
     * @param \StructType\JPSOAP_HotelAvailStopSale[] $stopSale
     */
    public function __construct(array $stopSale = array())
    {
        $this
            ->setStopSale($stopSale);
    }
    /**
     * Get StopSale value
     * @return \StructType\JPSOAP_HotelAvailStopSale[]|null
     */
    public function getStopSale()
    {
        return $this->StopSale;
    }
    /**
     * Set StopSale value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_HotelAvailStopSale[] $stopSale
     * @return \ArrayType\ArrayOfJPSOAP_HotelAvailStopSale
     */
    public function setStopSale(array $stopSale = array())
    {
        foreach ($stopSale as $arrayOfJPSOAP_HotelAvailStopSaleStopSaleItem) {
            // validation for constraint: itemType
            if (!$arrayOfJPSOAP_HotelAvailStopSaleStopSaleItem instanceof \StructType\JPSOAP_HotelAvailStopSale) {
                throw new \InvalidArgumentException(sprintf('The StopSale property can only contain items of \StructType\JPSOAP_HotelAvailStopSale, "%s" given', is_object($arrayOfJPSOAP_HotelAvailStopSaleStopSaleItem) ? get_class($arrayOfJPSOAP_HotelAvailStopSaleStopSaleItem) : gettype($arrayOfJPSOAP_HotelAvailStopSaleStopSaleItem)), __LINE__);
            }
        }
        $this->StopSale = $stopSale;
        return $this;
    }
    /**
     * Add item to StopSale value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_HotelAvailStopSale $item
     * @return \ArrayType\ArrayOfJPSOAP_HotelAvailStopSale
     */
    public function addToStopSale(\StructType\JPSOAP_HotelAvailStopSale $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JPSOAP_HotelAvailStopSale) {
            throw new \InvalidArgumentException(sprintf('The StopSale property can only contain items of \StructType\JPSOAP_HotelAvailStopSale, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->StopSale[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JPSOAP_HotelAvailStopSale|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JPSOAP_HotelAvailStopSale|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JPSOAP_HotelAvailStopSale|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JPSOAP_HotelAvailStopSale|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JPSOAP_HotelAvailStopSale|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string StopSale
     */
    public function getAttributeName()
    {
        return 'StopSale';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJPSOAP_HotelAvailStopSale
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
